#include<unistd.h>
#include<errno.h>
#include<stdio.h>
#include<stdlib.h>
/* #define _REENTRANT */    /* basic 3-lines for threads */
#include <pthread.h>
/* #include <thread.h>  */
#include<time.h>


void err_abort(const int i){
 printf("%d:%s\n",i,strerror(errno));
 exit(-1);
}

int total, loopmax;

int val = 0;


typedef 
 struct rw_monitor{
   pthread_mutex_t m;
   pthread_cond_t okr, okw;
   int writing,reading,wr,ww;
 } rw_monitor_t;


void startread(rw_monitor_t *m){
  pthread_mutex_lock(&(m->m));
  if ((m->writing) || (m->ww)){
   m->wr++;
   pthread_cond_wait(&(m->okr),&(m->m));
   m->wr--;
  }
  m->reading++;
  if (m->wr && !m->ww) pthread_cond_signal(&(m->okr));
  pthread_mutex_unlock(&(m->m));
}

void endread(rw_monitor_t *m){
  pthread_mutex_lock(&(m->m));
  m->reading--;
  if ((!m->reading) && (m->ww)) pthread_cond_signal(&(m->okw));
  pthread_mutex_unlock(&(m->m));
}

void startwrite(rw_monitor_t *m){
  pthread_mutex_lock(&(m->m));
  if ((m->writing) || (m->reading)){
    m->ww++;
    pthread_cond_wait(&(m->okw),&(m->m));
    m->ww--;
  }
  m->writing = 1;
  pthread_mutex_unlock(&(m->m));
}
  

void endwrite(rw_monitor_t *m){
  pthread_mutex_lock(&(m->m));
  m->writing=0;
  if (m->wr) pthread_cond_signal(&(m->okr));
  else if (m->ww) pthread_cond_signal(&(m->okw));
  pthread_mutex_unlock(&(m->m));
}
 
long timeconv(const struct timespec t){
  return t.tv_nsec;
}

rw_monitor_t mrw;
int rc =0;

void *rthread(void *arg){
 int *i=(int *) malloc(sizeof(int));
 int j;
 pthread_t tid = pthread_self();
 int aux;
 rc++;
 printf("read %d\n",rc);
/*  pthread_detach(tid); */
 for (j=0;j<loopmax;j++){
  startread(&mrw);
   aux = val;
  printf("Read thread %d: got %d->%d:%d:%d:%d\n",tid,aux,mrw.reading,mrw.wr,mrw.writing,mrw.ww);
  endread(&mrw);
 }
 startread(&mrw);
 *i=val;
 endread(&mrw);
 printf("read %d->%d:%d:%d:%d\n",rc,mrw.reading,mrw.wr,mrw.writing,mrw.ww);
 rc--;
 return i;
}
void *wthread(void *arg){
 int *i=(int *) malloc(sizeof(int));
 int j;
 pthread_t tid = pthread_self();
 int aux;

/*  pthread_detach(tid); */
 for (j=0;j<loopmax;j++){
  startwrite(&mrw);
   aux = val;
   aux++;
   val=aux;
  printf("Write thread %d: wrote %d!%d:%d:%d:%d\n",tid,aux,mrw.reading,mrw.wr,mrw.writing,mrw.ww);
  endwrite(&mrw);
/*   sleep(2);  */
 }
 startwrite(&mrw);
 aux=val;
 aux++;
 val=aux;
 endread(&mrw);
 *i=aux;
 return i;
}

int main(int argc, char **argv){
 int i=0,j;
 pthread_t *pt;
 int *lstrd,
     *lstwrt;

 struct timespec t0,t1;
 int status; 

 mrw.writing=mrw.reading=mrw.wr=mrw.ww=0;
 pthread_mutex_init(&mrw.m,0);
 pthread_cond_init(&mrw.okw,0);
 pthread_cond_init(&mrw.okr,0);

 sscanf(argv[1],"%d",&total);
 sscanf(argv[2],"%d",&loopmax);
 pt= (pthread_t *) malloc((total+1)*sizeof(pthread_t));

 
/*   printf("%d\n",pthread_getconcurrency()); */

/*  clock_gettime(CLOCK_REALTIME,&t0); */
 
 

 for(i=0;i<total;i++){ 
   status = pthread_create(pt+i,NULL,&rthread,&i);
   if (status > 0) err_abort(status);
 }
 status = pthread_create(pt+total,NULL,&wthread,&i);
 pthread_join(pt[total],(void **)&lstwrt);
 pthread_join(*pt,(void **) &lstrd);

 printf("W:%d:R:%d\n",*lstwrt,*lstrd);

 
/*  clock_gettime(CLOCK_REALTIME,&t1); */


/*  printf("Total time:%ld:%ld:%ld:%ld:%ld\n",t0.tv_sec,t0.tv_nsec,t1.tv_sec,t1.tv_nsec,t1.tv_nsec-t0.tv_nsec); */

 exit(0);

}


