//
// Laboratory for Scientific Computing
// http://www.lam-mpi.org/tutorials/
// University of Notre Dame
//
// MPI Tutorial
// Lab : Image processing -- sum of squares
//
// Mail questions regarding tutorial material to mpi@lam-mpi.org
//

#include <iostream.h>
#include <math.h>
#include "mpi++.h"

extern "C" {
extern int loadtiff_(char *fileName, unsigned char *image, int *iw, int *ih);
extern int dumptiff_(char *fileName, unsigned char *image, int *w, int *h);
}

int
main(int argc, char *argv[])
{
  int width = 500, height = 500;
  int rank, comm_size, sum, my_sum;
  unsigned char pixels[65536];
  unsigned char recvbuf[65536];
  int i, val;
  int numpixels, my_count;
  double rms;

  MPI::Init(argc, argv);
  rank = MPI::COMM_WORLD.Get_rank();
  comm_size = MPI::COMM_WORLD.Get_size();
  
  if (rank == 0) {

    /* Load the Image */

    height = 500;
    width = 500;
    loadtiff_("irish.tif", pixels, &width, &height);
    numpixels = width * height;

    /* Calculate the number of pixels in each sub image */

    my_count = numpixels / comm_size;
  }

  /* Broadcasts my_count to all the processes */

  /* Scatter the image into the recvbuf buffer*/

  /* Take the sum of the squares of the partial image */

  /* Find the global sum of the squares = sum */
  
  /* Rank 0 calculates the root mean square */

  if (rank == 0) {
    rms = sqrt ((double) sum / (double) numpixels);
    printf("RMS = %lf\n", rms);
  }

  MPI::Finalize();
  return 0;
}
